/*	Stuff dealing with classes as members of polpns     */
#define NOTGLOB 1
#define CLASSES 1
#include "glob.c"


/*	-----------------------  s2id  ---------------------------   */
/*	Finds class index (id) from serial, or -3 if error    */
Sw s2id (ss)
	Sw ss;
{
	Sw k;  Class *clp;
	setpop ();
	if (ss < 0) goto error;
	for (k = 0;  k <= pop->hicl;  k++)	{
		clp = pop->classes[k];
	if (clp && (clp->type != Vacant) && (clp->serial == ss))
			goto gotit;
		}
error:
	printf ("No such class serial as %d", ss>>2);
	if (ss & 3) printf ("%c", (ss & 1) ? 'a' : 'b');
	printf ("\n");
	return (-3);

gotit:
	return (k);
}


/*	---------------------  setclass --------------------------   */
void setclass (ccl)
	Class *ccl;
{
	cls = ccl;
	cwt = cls->casewt;
	idad = cls->idad;
	if (idad >= 0) dad = pop->classes[idad];  else dad = 0;
	return;
}


/*	---------------------   makeclass  -------------------------   */
/*	Makes the basic structure of a class (Class) with vector of
ptrs to CVinsts and CVinsts filled in also EVinsts and ptrs.
	Uses nc = pop->nc.
	Returns index of class, or negative if no good  */

Sw makeclass ()
{
	PVinst *pvars;
	CVinst **cvars, *cvi;
	EVinst **evars, *evi;
	Sw i, kk;

	nv = vst->nv;
	pvars = pop->pvars;
/*	Find a vacant slot in the popln's classes vec   */
	for (kk = 0; kk < pop->mncl; kk++)	{
		if (! pop->classes[kk]) goto gotit;
	/*	Also test for a vacated class   */
		if (pop->classes[kk]->type == Vacant) goto vacant1;
		}
	printf ("Popln full of classes\n");
	goto nospace;

gotit:
	cls = (Class *) gtsp(1, sizeof (Class));
	if (!cls)	goto nospace;
	pop->classes[kk] = cls;
	pop->hicl = kk;	/* Highest used index in pop->classes */
	cls->id = kk;

/*	Make vector of ptrs to CVinsts   */
	cvars = cls->basics = (CVinst**) gtsp(1, nv * sizeof (CVinst*));
	if (! cvars) goto nospace;

/*	Now make the CVinst blocks, which are of varying size   */
	for (i = 0; i < nv; i++)	{
		pvi = pvars + i;
		avi = vlist + i;
		cvi = cvars[i] = (CVinst*) gtsp(1, avi->basicsize);
		if (! cvi) goto nospace;
	/*	Fill in standard stuff  */
		cvi->id = avi->id;
		}

/*	Make EVinst blocks and vector of pointers  */
	evars = cls->stats = (EVinst**) gtsp(1, nv * sizeof (EVinst*));
	if (! evars) goto nospace;

	for (i = 0; i < nv; i++)	{
		pvi = pvars + i;
		avi = vlist + i;
		evi = evars[i] = (EVinst*) gtsp(1, avi->statssize);
		if (! evi) goto nospace;
		}

/*	Stomp on ptrs as yet undefined  */
	cls->type = 0;
	goto donebasic;

vacant1:	/* Vacant type shows structure set up but vacated.
		Use, but set new (Vacant) type,  */
	cls = pop->classes[kk];
	cvars = cls->basics;
	evars = cls->stats;
	cls->type = Vacant;

donebasic:
	cls->cbcost = 0.0;
	cls->cnt = 0.0;
	cls->ison1 = cls->ison2 = -1;
	cls->idad = -1;
	for (i = 0; i < nv; i++) cvars[i]->signif = 1;
	pop->ncl ++;
	if (kk > pop->hicl) pop->hicl = kk;
	if (cls->type == Vacant) cls->type = 0;
	for (i = 0; i < nv; i++) evars[i]->cnt = 0.0;
	cls->age = 0;
	cls->cnt = 0.0;
	return (kk);

nospace:
	printf ("No space for new class\n");
	return (-1);
}


/*	-----------------------  printclass  -----------------------  */
/*	To print parameters of a class    */
	char *typstr[] = {"typ?"," POP","LEAF","typ?"," Sub","typ?",\
"typ?","typ?","COMB"};
void print1class (clp, full, fl)
	Class *clp;  Sw full;  FILE *fl;
{
	Sw i;

	fprintf (fl, "\nS# %s", sers(clp));
	fprintf (fl, " %s  ", typstr[((Sw)clp->type)]);
	fprintf (fl, "Age# %4d  SampSz# %8.1f  RelAb %5.3f  Sz %8.1f",
		clp->age, clp->cnt, clp->relab, clp->newcnt);
	fprintf (fl, "\n");
	fprintf (fl, "Pcost %9.2f  Tcost %9.2f  Total %9.2f\n",
		clp->cbpcost, clp->cbtcost, clp->cbcost);
	if (! full) return;
	for (i = 0; i < vst->nv; i++)	{
		avi = vlist + i;  vtp = avi->vtp;
		(*vtp->vprint) (clp, i, fl);
		}
	return;
}


void printclass (kk, full, fl)
	Sw kk, full;  FILE *fl;
{
	Class *clp;
	Sw ki;
	if (kk >= 0)  {
		clp = pop->classes[kk];
		print1class (clp, full, fl);
		return;  }
	if (kk < -2) {printf("%d passed to printclass\n",kk); return; }
	setpop ();
	if (kk == -1) ki = Pop+Leaf;  else ki = Pop+Leaf+Sub+TC;
	findall (ki);
	sortbyser ();
	for (ki = 0; ki < numson; ki++)  {
		print1class (sons[ki], full, fl);
		}
	return;
}


/*	-------------------------  cleartcosts  ------  */
/*	Clears tcosts (cbtcost). Also clears newcnt,
newvsq, and calls clearstats for all variables   */
void cleartcosts (ccl)
	Class *ccl;
{
	Sw i;

	setclass (ccl);
	cls->mlogab = - log (cls->relab);
	cls->cdtcost = cls->cbtcost = 0.0;
	cls->cbcost = 0.0;
	cls->newcnt = 0.0;
	for (i = 0; i < vst->nv; i++)	{
		vtp = vlist[i].vtp;
		(*vtp->clearstats) (i);
		}
	return;
}


/*	----------------------  costvarall  --------------------------  */
/*	Does costvar on all vars of class for the current thing, setting
cls->casecost according to use of class  */
void costvarall (ccl)
	Class *ccl;
{
	Sw iv;

	setclass (ccl);
	scasecost = cls->mlogab;  /* Abundance cost */
	for (iv = 0; iv < vst->nv; iv++)	{
		avi = vlist + iv;  if (avi->idle) goto vdone;
		vtp = avi->vtp;
		(*vtp->costvar) (iv);
	/*	will add to scasecost  */
	vdone:	;
		}

	cls->casecost = scasecost;
	return;
}



/*	----------------------  derivvarall  ---------------------    */
/*	To collect derivative statistics for all vars of a class   */
void derivvarall (ccl)
	Class *ccl;
{
	Sw iv;

	setclass (ccl);
	cls->newcnt += cwt;
	for (iv = 0; iv < nv; iv++)	{
		avi = vlist + iv;  if (avi->idle) goto vdone;
		vtp = avi->vtp;
		(*vtp->derivvar) (iv);
	vdone:	;
		}

/*	Collect case thing costs   */
/*	But not if root class  */
	if (cls->type != Pop) cls->cbtcost += cwt * cls->casecost;

	return;
}


/*	--------------------  adjustclass  -----------------------   */
/*	To compute pcosts of a class, and if needed, adjust params  */
void adjustclass (ccl)
	Class *ccl;
{
	Sw iv;
	Class *son;

	setclass (ccl);
	if (control & AdjPr)	{
		cls->cnt = cls->newcnt;
		cls->relab = (cls->cnt + 0.5) / (samp->nact + 0.5 * pop->nleaf);
		}

/*	But :  */
	if (cls->type == Pop) {
		cls->relab = 1.0;
		}
	else if ((cls->type == Sub) && (cls->age < MinSubAge))  {
		cls->relab = 0.5 * dad->relab;
		}
	else if (cls->type == Sub)	{
	/*	Set relab as proportion of dad's relab. Find sib  */
		if (cls->id == dad->ison1) son = pop->classes [dad->ison2];
				     else  son = pop->classes [dad->ison1];
		cls->relab = dad->relab * (cls->cnt + 0.5) /
				(cls->cnt + son->cnt + 1.0);
		}
	else if (cls->type == TC)  {
		cls->relab = pop->classes[cls->ison1]->relab +
				pop->classes[cls->ison2]->relab;
		}

	cls->cbpcost = 0.5 * log (samp->nact / (12.0 * cls->relab));
/*	This adds in the Fisher component of the relab costs.  */
	cls->mlogab = -log (cls->relab);

	cls->cdtcost = cls->newcnt * cls->mlogab;
/*	cdtcost will get new tcost based on revised params.  */
	for (iv = 0; iv < vst->nv; iv++) {
		avi = vlist + iv;  if (avi->idle) goto vdone;
		vtp = avi->vtp;
		(*vtp->adjust) (iv);
	/*	adjust adds varible param cost to cls->cbpcost  */
	/*	Also adds to cls->cdtcost  */
	vdone:	;
		}

	if (cls->type == Leaf) cls->cbcost = cls->cbpcost + cls->cbtcost;

	if (control & AdjPr) cls->age++;
	return;
}


/*	--------------------  killsons ------------------------------- */
/*	To delete the sons of a class  */
void killsons (kk)
	Sw kk;
{
	Class *clp, *son;

	if (! (control & AdjTr)) return;
	if (kk < 0) return;
	clp = pop->classes [kk];
	if ((! clp) || (clp->type == Vacant)) return;
	if (clp->ison1 < 0) return;
	son = pop->classes[clp->ison1];
	son->type = Vacant;  son->idad = Deadkilled;
	son = pop->classes[clp->ison2];
	son->type = Vacant;  son->idad = Deadkilled;
	clp->ison1 = clp->ison2 = -1;
	pop->ncl -= 2;
	return;
}


/*	--------------------  splitleaf ------------------------   */
/*	If kk has subs, kill it and make the subs leaves  */
/*	Returns 0 if succeeds  */
Sw splitleaf (kk)
	Sw kk;
{
	Class *son;
	cls = pop->classes[kk];
	if (!(cls->type & (Pop+Leaf)) || (cls->ison1 < 0)) return (1);

	son = pop->classes[cls->ison1];
	son->type = Leaf;  son->idad = root;  son->ison1 = son->ison2 = -1;
	son->serial = 4 * pop->nextserial;  pop->nextserial++;
	son->age = 2;

	son = pop->classes[cls->ison2];
	son->type = Leaf;  son->idad = root;  son->ison1 = son->ison2 = -1;
	son->serial = 4 * pop->nextserial;  pop->nextserial++;
	son->age = 2;

	pop->nleaf += 2;

	cls->ison1 = cls->ison2 = -1;
	if (cls->type != Pop)	{
		cls->type = Vacant;
		pop->nleaf --;
		pop->ncl --;
		}
	return (0);
}

/*	---------------  clobber  ------------ */
/*	To remove all classes of a popln except its root and make
	numc leaves all copies of the popln. */
void clobber (numc)
	Sw numc;
{
	Sw k, iv, nch;
	Sf ab;
	CVinst *fcvi, *cvi;
	EVinst *fevi, *evi;

	if (numc < 1) {
		printf ("Clobber needs to make at least one leaf.\n");
		return;
		}
	pop = ctx.popln;
	root = pop->root;
	rootcl = pop->classes [root];
	for (k = 0; k <= pop->hicl; k++)	{
		cls = pop->classes[k];
		if (cls->id != root)	{
			cls->type = Vacant;  cls->idad = Deadkilled;
			}
		}
	pop->ncl = 1;  pop->hicl = root;
	pop->tcic = -1;
	rootcl = cls = pop->classes [root];
	cls->ison1 = cls->ison2 = -1;
	cls->serial = 0;  pop->nextserial = 1;
	cls->age = 0;
	cls->type = Pop;

	clearbadm();

/*	Make numc leaves  */
	ab = 1.0 / numc;
next:
	k = makeclass();
	cls = pop->classes[k];
	nch = ((char*) & cls->id) - ((char*) cls);
	cmcpy (cls, rootcl, nch);
	cls->ison1 = cls->ison2 = -1;
	cls->idad = root;
/*      Copy Basics. the structures should have been made.  */
        for (iv = 0; iv < nv; iv++)     {
                fcvi = rootcl->basics[iv];
                cvi = cls->basics[iv];
                nch = vlist[iv].basicsize;
                cmcpy (cvi, fcvi, nch);
                }

/*      Copy stats  */
        for (iv = 0; iv < nv; iv++)        {
                fevi = rootcl->stats[iv];
                evi = cls->stats[iv];
                nch = vlist[iv].statssize;
                cmcpy (evi, fevi, nch);
                }
	cls->newcnt = cls->cnt = rootcl->cnt * ab;
	cls->type = Leaf;
	cls->serial = pop->nextserial<<2;  pop->nextserial++;
	pop->nleaf ++;
	cls->age = 1;
	cls->relab = ab;
	numc--;
	if (numc > 0) goto next;

	while (rootcl->age < 3) doall (1);
	nosubs = 0;  tidy(1);
	return;
}


/*	-------------------------  setsig  ----------------------  */
/*	returns signif code for cost cost benefit 'ben'  */
Sw setsig (ben)
	Sf ben;
{
	Sw i;

	for (i = 0; i < 5; i++)	{
		if (ben < siglev[i]) break;
		}
	return (i);
}


/*	----------------------------  prvhead  ------------------  */
/*	To write a standard heading for a variable-in-class report */
void prvhead (ccl, iv, fl)
	Class *ccl;  Sw iv;
        FILE *fl;
{
	CVinst *cvi;  EVinst *evi;

	setclass (ccl);  cvi = cls->basics[iv];
	evi = cls->stats[iv];
        fprintf (fl, "V %3d  %s\n", iv+1, avi->name);
        fprintf (fl,
          "  #%s  SampSz# %8.1f  Cnt %8.1f  Pcost%6.1f  Tcost%8.1f\n",
                sigstr [cvi->signif],
                cvi->samplesize, evi->cnt, evi->spcost, evi->stcost);
	return;
}


/*	-----------------------  invhead  -------------------  */
/*	To read standard variable heading from a .prep type file */
Sw invhead (ccl, iv, fl)
        Class *ccl;
        Sw iv;
        FILE *fl;
{
	CVinst *cvi;  char flag[80];
	Sw err;

	setclass (ccl);  cvi = cls->basics[iv];
	err = 0;
	adv (fl);
	if (fscanf (fl, "%s", flag) != 1) { err = 2;  goto finish; }
	if (flag[0] == 'I') cvi->signif = 0;  else cvi->signif = 1;
	adv (fl);
	if (fscanf (fl, "%lf", &cvi->samplesize) != 1) err = 3;
	if ((cvi->samplesize < 2.0) || (cvi->samplesize > ccl->cnt))
		cvi->samplesize = cls->cnt;
finish:
	return (err);
}
/*zzzz*/
