#define NOTGLOB 1
#define DOALL 1
#include "glob.c"




/*	-------------------- sran, fran, uran -------------------------- */
Sw rseed;  static Sf rcons = (1.0 / (2048.0 * 1024.0 * 1024.0));
#define M32 0xFFFFFFFF
#define B32 0x80000000
Sw sran()
{
	Sw js;
	rseed = 69069 * rseed + 103322787;
	js = rseed & M32;
	return (js);
}

Sw uran()
{
	Sw js;
	rseed  = 69069 * rseed + 103322787;
	js = rseed & M32;
	if (js & B32) js = M32 - js;
	return (js & M32);
}

Sf fran()
{
	Sw js;
	rseed  = 69069 * rseed + 103322787;
	js = rseed & M32;
	if (js & B32) js = M32 - js;
	return (rcons * js);
}


/*	-------------------  findall  ---------------------------------  */
/*	Finds all classes of type(s) shown in bits of 'typ'.
	(Pop=1, Leaf=2, Sub=4, TC = 8) so if typ = 15,will find all classes.*/
/*	Sets the classes in 'sons[]'  */
/*	Puts count of classes found in numson */
void findall (typ)
	Sw typ;
{
	Sw i, j;
	Class *clp;

	setpop ();
	tidy (1);
	j = 0;
	for (i = 0; i <= pop->hicl; i++)	{
		clp = pop->classes[i];
		if (clp && (clp->type & typ))	{
			sons[j] = clp;  j++;
			}
		}
	numson = j;
	return;
}


/*	--------------------  tidy  -------------------------------  */
/*	Reconstructs ison1, ison2 from idad-s. If hit
	and AdjTr, kills classes which are too small.
Also deletes singleton subclasses.  Re-counts pop->ncl, pop->hicl, pop->nleaf.
	*/
void tidy (hit)
	Sw hit;
{
	Class *clp, *dad;
	Sw i, kkd, ndead, newhicl, cause;

	deaded = 0;
	if (! pop->nc) hit = 0;
recheck:
/*	First check that 'sons' of TC class still exist  */
/*	and that control admits a tree change  */
	if (pop->tcic >= 0)	{
		dad = pop->classes[pop->tcic];
		if ( (! (control & AdjTr)) ||
		    (! pop->classes[dad->ison1]) ||
		    (pop->classes[dad->ison1]->type != Leaf) ||
		    (! pop->classes[dad->ison2]) ||
		    (pop->classes[dad->ison2]->type != Leaf))  {
			dad->type = Vacant;
			pop->tcic = -1;
			}
		}
	ndead = 0;
	for (i = 0; i <= pop->hicl; i++)	{
		clp = pop->classes[i];
		if (! clp) goto skip1;
		if (clp->type == Vacant) goto skip1;
		if (clp->type != TC) clp->ison1 = clp->ison2 = -1;
		if (i == root) goto skip1;
		kkd = clp->idad;
		if (kkd < 0) {printf("Dad error in tidy\n"); for(;;); }
		if ((!pop->classes[kkd]) || (pop->classes[kkd]->type == Vacant))
			{ cause = Deadorphan;  goto diehard;  }
		if (hit)	{
		if ((clp->type==Sub) &&
			((clp->age > MaxSubAge) || nosubs))
			{ cause = Dead;  goto diehard; }	}
		if (hit & (clp->cnt < MinSize))
			{ cause = Deadsmall; goto die; }
		goto skip1;

	die:
		if (! (control & AdjTr)) goto skip1;
	diehard:
		if (clp->type == TC)	{
			setbadm (1, pop->classes[clp->ison1]->serial,
				    pop->classes[clp->ison2]->serial);
			pop->tcic = -1;
			}
		clp->idad = cause;  clp->type = Vacant;  ndead++;
	skip1:	;
		}

	deaded += ndead;
	if (ndead) goto recheck;

/*	No more classes to kill for the moment.  Relink subs  */
	pop->ncl = 0;  kkd = 0;
	for (i = 0; i <= pop->hicl; i++)	{
		clp = pop->classes[i];
		if ((!clp) || (clp->type == Vacant)) goto skip2;
		if (i == root) goto skip2;
		if (clp->type & (Leaf + TC))	{
			clp->idad = root;  goto skip2;
			}
	/*	Must be a subclass  */
		kkd = clp->idad;
		dad = pop->classes [kkd];
		if (clp->serial & 1) dad->ison1 = i;
			else dad->ison2 = i;
	skip2:	;
		}

/*	Check for singleton sons   */
	for (kkd = 0; kkd <= pop->hicl; kkd++)	{
		dad = pop->classes[kkd];
		if (dad->type == Vacant) goto skip3;
		if (dad->ison1 < 0)	{
			if (dad->ison2 < 0) goto skip3;
			i = dad->ison2;  goto killsing;
			}
		else	{
			if (dad->ison2 >= 0) goto skip3;
			i = dad->ison1;  goto killsing;
			}
	killsing:
		clp = pop->classes[i];
		clp->idad = cause;  clp->type = Vacant;  ndead++;
		dad->ison1 = dad->ison2 = -1;
	skip3:	;
		}
	if (ndead) goto recheck;

	kkd = 0;
	if (! hit) goto finish;
	if (! (control & AdjTr)) goto finish;
	if (! newsubs) goto finish;
/*	Add subclasses to large-enough leaves  */
	for (i = 0; i <= pop->hicl; i++)	{
		dad = pop->classes[i];
		if (dad->type != Leaf) goto skip4;
		if (dad->ison1 >= 0) goto skip4;
		if (dad->cnt < (2.1 * MinSize)) goto skip4;
		if (dad->age < MinAge) goto skip4;
		makesubs (i);  kkd++;
	skip4:	;
		}

finish:
	if ((pop->tcic >= 0) && (pop->classes[pop->tcic]->type == Vacant)) {
		flp();  printf ("TC class index %3d Vacant", pop->tcic);
		pop->tcic = -1;
		}
	deaded = 0;
/*	Re-count classes, leaves etc.  */
	pop->ncl = pop->nleaf = newhicl = kkd = 0;
	for (i = 0; i <= pop->hicl; i++)	{
		clp = pop->classes[i];
		if (! clp) goto skip5;
		if (clp->type == Vacant) goto skip5;
		if (clp->type == Leaf) pop->nleaf++;  pop->ncl++;
		newhicl = i;
		if (clp->serial > kkd) kkd = clp->serial;
	skip5:	;
		}
	pop->hicl = newhicl;  pop->nextserial = (kkd >> 2) + 1;
	return;
}


/*	------------------------  doall  --------------------------   */
/*	To do a complete cost-assign-adjust cycle on all things.
	*/
Sw doall (ncy)
	Sw ncy;
{
	Sw nit, nfail, nn, ic, ncydone, ncyask, nact, jolt;
	Sf oldcost, sum;
	Class *sub1, *sub2;

	setpop();
	nact = samp->nact;
	nfail = nit = ncydone = 0;  ncyask = ncy;
	oldcost = pop->cost;
	jolt = 0;  /* Will be set if a cycle splits or combines  */


again:
/*	If the Pop class has not been adjusted to the sample yet, just
	do this.  */
	if ((control & AdjPr) && (rootcl->age < 3))	{
		newsubs = 0;
		sons[0] = rootcl;  numson = 1;
		rootcl->type = Leaf;
		goto foundall;
		}
	if ((nit % NewSubsTime) == 0)  newsubs = 1; else newsubs = 0;
	if (newsubs)	{
		if (nit > NewSubsTime)  {
			trackbest (0);
			}
		if ((pop->tcic < 0)||(pop->classes[pop->tcic]->age > MaxSubAge))
			if (control & AdjTr)  {
				trycombine();
				}
		}
again2:
	jolt = jolt >> 1;
	if (nosubs || jolt) newsubs = 0;
	tidy (1);
	findall (Leaf+Sub+TC);
foundall:
	if (pop->nleaf == 0) goto finish;
	for (ic = 0; ic < numson; ic++)	{
		cleartcosts (sons[ic]);
		}
	pop->cost = 0.0;

	for (nn = 0; nn < samp->nc; nn++)	{
		docase (nn, 1);
		}

/*	All classes in sons[] now have stats assigned to them.
	But first, check all newcnt-s for vanishing classes.
	*/
	if (control == (AdjPr + AdjTr))  {
		for (ic = 0; ic < numson; ic++) {
			if (sons[ic]->newcnt < MinSize)  {
				sons[ic]->cnt = 0.0;
				rep ('K');  jolt = 2;  goto again2;
				}
			}	
		}

/*	Adjust all classes  */
	for (ic = 0; ic < numson; ic++) {
		adjustclass (sons[ic]);
		}
	if (control & AdjPr) cycle++;

/*	Look for possible combine, splits  */
/*	But don't if previous cycle caused a combine or split  */
	if (jolt) goto alldone;
	if (control & AdjTr)	{
		for (ic = 0; ic < numson; ic++)	{
			setclass (sons[ic]);
			if (cls->type == (Pop + Sub)) goto doneclass;
			if (cls->ison1 < 0) goto doneclass;
			sub1 = pop->classes [cls->ison1];
			sub2 = pop->classes [cls->ison2];

			if (cls->type == Leaf)	{
			/*  Test cbcost of sub1 to see if split good.
			   cbcost holds increasesd cost of things if split.
			   Must add in increased param. cost.  */
				sum = sub1->cbcost + sub1->cbpcost +
				      sub2->cbpcost - cls->cbpcost;
			/*  The cost of specifying the relabs of leaves is
			    -0.5*Sum_k {logp_k} + (K-1)/2 log (N/12)
				- log ((K-1)!), where N = numcases, K = leaves.
			    A term 0.5*log (N/(12*p_k)) is included in each
				cbpcost, so we need only adjust for the change
				in the prior cost -log ((K-1)!).
			    The split will increase K to K+1 with increased
				cost of -log K.
					*/
				sum -= log ((Sf)pop->nleaf);
				sub1->cbcost = sum;
				if (sum > 0.0) goto doneclass;
				if (sub1->age <= 2*MinSubAge) goto doneclass;
			/*	The split is worth while.   */
			/*	Make the subs Leafs and kill cls  */
				splitleaf (cls->id);
				rep ('S');
				flp();
	printf ("Cycle%7d  Splitting%4d into%4d,%4d  Ben%6.2f\n", cycle,
		cls->serial>>2, sub1->serial>>2, sub2->serial>>2, -sum);
				setbadm (1, sub1->serial, sub2->serial);
				jolt = 2;  goto again2;
				}

			if ((cls->type == TC) && (cls->age > 3))  {
			/*	See if combine worthwhile  */
				sum = cls->cbcost + cls->cbpcost -
					sub1->cbpcost - sub2->cbpcost -
					+ log ((Sf)(pop->nleaf-1));
				cls->cbcost = sum;
				if (sum > 0.0) goto doneclass;
			/*	Combine is worthwhile. Kill subs of sub1,sub2 */
				killsons (sub1->id);  killsons (sub2->id);
				sub1->idad = sub2->idad = cls->id;
				sub1->type = sub2->type = Sub;
				cls->type = Leaf;  cls->idad = root;
				cls->serial = pop->nextserial << 2;
				pop->nextserial++;
				cls->age = MinAge;
				rep ('C');
				flp();
	printf ("Cycle%7d  Combining%4d,%4d into%4d  Ben%6.2f\n",
		cycle, sub1->serial>>2, sub2->serial>>2, cls->serial>>2, -sum);
				sub1->serial = cls->serial + 1;
				sub2->serial = cls->serial + 2;
				sub1->age = sub2->age = 1;
				pop->nleaf --;
				pop->tcic = -1;
				jolt = 2;  goto again2;
				}
		doneclass:	;
			}
		}

/*	Recompute total cost into pop->cost   */
alldone:
	sum = 0.0;
	nn = 0;		/* Will count leaves */
	for (ic = 0; ic <= pop->hicl; ic++)	{
		cls = pop->classes [ic];
		if (cls && (cls->type == Leaf))	{
			cls->cbcost = cls->cbtcost + cls->cbpcost;
			sum += cls->cbpcost;
			if (nn) sum -= log ((Sf) nn);
			nn++;
			}
		}

/*	If we are just adjusting root as if a leaf, repeat.  */
	if (rootcl->type == Leaf)  {
		rootcl->type = Pop;
		}

/*	The sum contains nleaf times 0.5 log (nact/12) which is one
	too many.   */
	sum -= 0.5 * log (rootcl->cnt / 12.0);
	pop->cost += sum;
	pop->nleaf = nn;

	if (pop->cost < (oldcost - MinGain))  {
		nfail = 0;  oldcost = pop->cost;  rep('A');
		}
	else  { nfail++;  rep('a'); }

	if (nfail > GiveUp)	goto finish;
	if ((! usestdin) && hark (commsbuf.inl)) goto kicked;
	ncydone++;  nit++;  if (nit < ncy) goto again;
	if (ncydone >= ncyask) ncydone = -1;  goto finish;

kicked:
	flp(); printf ("Doall interrupted after %4d steps\n", ncydone);

finish:
	if (control)	{
		pop->samplesize = samp->nact;
		strcpy (pop->samplename, samp->name);
		}
	return (ncydone);
}


/*	-----------------------  docase  -----------------------------   */
/*	It is assumed that all classes have parameter info set up, and
	that all cases have scores in all classes.
	Assumes findall() has been used to find classes and set up
sons[], numson
	If 'derivs', calcs derivatives. Otherwize not.
	*/
/*	Defines and uses a prototypical 'Saux' containing missing and Datum
	fields */
typedef struct PSauxst	{
	Sw missing;
	Sf dummy;
	Sf xn;
	} PSaux;

void docase (cse, derivs)
	Sw cse, derivs;
{
	Sf mincost, sum;
	Class *sub1, *sub2;
	PSaux *psaux;
	Sw clc, i;

	rec = recs + cse * reclen;  /*  Set ptr to case record  */
	thing = cse;
	if (! *rec) goto casedone1;  /* Inactive thing */

/*	Unpack data into 'xn' fields of the Saux for each variable. The
'xn' field is at the beginning of the Saux. Also the "missing" flag. */
	for (i = 0; i < nv; i++)	{
		loc = rec + svars[i].offset;
		psaux = (PSaux *) svars[i].saux;
		if (*loc == 1)	{ psaux->missing = 1; }
		else	{
			psaux->missing = 0;
			cmcpy (& (psaux->xn), loc+1, vlist[i].vtp->datsize);
			}
		}

/*	Deal with every class, as set up in sons[]  */
	clc = 0;
	while (clc < numson)	{
		setclass (sons[clc]);
		costvarall (cls);
		clc ++;
		}
/*	Have casecost set in all classes for this case.  Get weights  */
/*	Clear all casewts   */
	for (clc = 0;  clc < numson;  clc++) sons[clc]->casewt = 0.0;
	mincost = 1.0e30;
	for (clc = 0; clc < numson; clc++)	{
		cls = sons[clc];
		if (cls->casecost < mincost) mincost = cls->casecost;
		}
	sum = 0.0;
	for (clc = 0; clc < numson; clc++) {
		sons[clc]->casewt = exp (mincost - sons[clc]->casecost);
		if (sons[clc]->type == Leaf) sum += sons[clc]->casewt;
		}
/*	Have unnormalized class probs in casewts, sum over leaves in sum.
	Can add basic thing cost into pop->cost.  */
	pop->cost += mincost - log (sum);

/*	Now normalize the leaf casewts, and for each leaf, get splitcost  */
/*	Also get joincost for TC class  */
	sum = 1.0 / sum;
	for (clc = 0; clc < numson; clc++) {
		cls = sons[clc];
		if (cls == rootcl) cls->casewt = 1.0;
		else cls->casewt *= sum;
		}
	for (clc = 0; clc < numson; clc++) {
		cls = sons[clc];
		if (cls->type == TC)	{
			sub1 = pop->classes [cls->ison1];
			sub2 = pop->classes [cls->ison2];
			sum = 1.0 - sub1->casewt - sub2->casewt
				  + cls->casewt;
			sum = 1.0 / sum;
		/*	Add to join cost in TC's cbcost  */
			cls->cbcost += log (sum);
			cls->casewt *= sum;
			}

		if (cls->type != Leaf) goto doneclass1;
		if (cls->ison1 < 0) goto doneclass1;
		if (cls->casewt == 0.0) goto doneclass1;
		sub1 = pop->classes [cls->ison1];
		sub2 = pop->classes [cls->ison2];
		sum = 1.0 - cls->casewt + sub1->casewt + sub2->casewt;
	/*	This gives what new sums-of-probs would be  */
		sum = 1.0 / sum;
		sub1->cbcost += log (sum);  /* Splitting cost */
		sub1->casewt *= sum;  sub2->casewt *= sum;
	/*	This gives caseweights in subs for re-estimation  */
	/*	But if subs young, constrain these weights  */
		if (sub1->age < (2*MinSubAge))	{
			if (sub1->age == 0) {
			/*	Random   */
				if (sran() < 0)	{
					sub1->casewt = cls->casewt;
					sub2->casewt = 0.0;
					}
				else	{
					sub1->casewt = 0.0;
					sub2->casewt = cls->casewt;
					}
				}
			else if (sub1->age < MinSubAge)	{
			/*	All to better   */
				if (sub1->casecost < sub2->casecost) {
					sub1->casewt = cls->casewt;
					sub2->casewt = 0.0;
					}
				else    {
					sub1->casewt = 0.0;
					sub2->casewt = cls->casewt;
					}
				}
			else if ((sub1->casewt+sub2->casewt) > 0.0) {
			/*	Distribute cls's weight  */
				sum = cls->casewt/ (sub1->casewt+sub2->casewt);
				sub1->casewt *= sum;
				sub2->casewt *= sum;
				}
			else	{
				sub1->casewt = sub2->casewt = 0.5 * cls->casewt;
				}
			}
	doneclass1:	;
		}

	rootcl->casewt = 1.0;
/*	Now all classes have casewt assigned, I hope. Can proceed to
collect statistics from this case  */
/*	But first, modify leaf weights if fix = Most_likely or Random  */
	if (fix == Partial) goto fixed;
	if (fix == Most_likely) goto mostlike;

/*	fix is Random.  Choose a leaf with prob. according to casewt.
	The sum over leaves of casewts should be one.  */
	sum = fran();
	for (clc = 0; clc < numson; clc++) {
		if (sons[clc]->type == Leaf)	{
			cls = sons[clc];
			sum -= cls->casewt;
			if (sum <= 0.0) goto chosen;
			}
		}
	goto chosen;

mostlike:	/* Give all weight to best leaf */
	sum = 0.0;  i = -1;
	for (clc = 0; clc < numson; clc++)      {
		if ((sons[clc]->type == Leaf) && (sons[clc]->casewt > sum)) {
			sum = sons[clc]->casewt;  i = clc;
			}
		}
	cls = sons[i];

chosen:		/* Place all weight on cls */
	for (clc = 0; clc < numson; clc++)	{
		if (sons[clc]->type == Leaf) sons[clc]->casewt = 0.0;
		}
	cls->casewt = 1.0;

fixed:
	for (clc = 0;  clc < numson;  clc++)   {
		cls = sons [clc];
		if (cls->casewt > 0.0)	{
			if (derivs) derivvarall (cls);
			else cls->newcnt += cls->casewt;
			}
		}

casedone1:
	return;
}
