#define NOTGLOB 1
#define POPLNS 1
#include "glob.c"
#include <string.h>

/*	-----------------------  setpop  --------------------------    */
void setpop ()
{
	pop = ctx.popln;   samp = ctx.sample;  vst = ctx.vset;
	nv = vst->nv;  vlist = vst->vlist;
	if (samp)	{
		nc = samp->nc;  svars = samp->svars;
		reclen = samp->reclen;  recs = samp->recs;
		}
	else		{
		nc = 0;  svars = 0;
		recs = 0;
		}
	pvars = pop->pvars;
	root = pop->root;
	rootcl = pop->classes [root];
	return;
}


/*	-----------------------   makepop   ---------------------   */
/*      To make a population with the parameter set 'vst'  */
/*	Returns index of new popln in poplns array	*/
/*	The popln is given a root class appropriate for the variable-set.
	*/
Sw makepop ()
{
	PVinst *pvars;
	Class *cls;
	Sw indx, i;

	samp = ctx.sample;  vst = ctx.vset;
	if (samp) nc = samp->nc;  else nc = 0;
/*	Find vacant popln slot    */
	for (indx = 0; indx < Maxpoplns; indx++)  {
		if (poplns[indx] == 0) goto gotit;
		}
	goto nospace;

gotit:
	pop = poplns[indx]= (Popln*) malloc (sizeof (Popln));
	if (! pop) goto nospace;
	pop->id = indx;
	pop->nc = 0;  strcpy (pop->samplename, "??");
	pop->samplesize = 0;
	strcpy (pop->vstname, vst->name);
	pop->pblks = pop->jblks = 0;
	ctx.popln = pop;
	for (i = 0; i < 80; i++) pop->name[i] = 0;
	strcpy (pop->name, "newpop");
	pop->dfname[0] = 0;
	pop->ncl = 0;	/*  Initially no class  */
	pop->tcic = -1;	/*  No TC class  */
	pop->cost = 1.0e30;

/*	Make vector of PVinsts    */
	pvars = pop->pvars = (PVinst*) gtsp(1, nv * sizeof (PVinst));
	if (! pvars) goto nospace;
/*	Copy from variable-set AVinsts to PVinsts  */
	for (i = 0; i < nv; i++)	{
		avi = vlist+i;  vtp = avi->vtp;    pvi = pvars+i;
		pvi->id = avi->id;
		pvi->paux = (Sc*) gtsp(1, vtp->pauxsize);
		if (! pvi->paux) goto nospace;
		}

/*	Make an empty vector of ptrs to class structures, initially
	allowing for MaxClasses classes  */
	pop->classes = (Class**) gtsp(1, MaxClasses * sizeof (Class*));
	if (! pop->classes) goto nospace;
	pop->mncl = MaxClasses;
	for (i = 0; i < pop->mncl; i++) pop->classes[i] = 0;

	strcpy (pop->samplename, samp->name);  pop->nc = nc;
	root = pop->root = makeclass ();
	if (root < 0) goto nospace;
	cls = pop->classes [root];
	cls->serial = 0;
	pop->nextserial = 1;
	cls->idad = -2;  /* root has no dad */
	cls->relab = 1.0;
/*	Set type as Pop  */
	cls->type = Pop;
	cls->cnt = 0.0;

	setpop();
	return (indx);

nospace:
	printf ("No space for another population\n");
	return (-1);
}


/*	----------------------  firstpop  ---------------------  */
/*	To make an initial population given a vset and a samp.
	Should return a popln index for a popln with a root class set up
and estimates done  */
/*      Defines and uses a prototypical 'Saux' containing missing and Datum
        fields */
typedef struct PSauxst  {
        Sw missing;
        Sf dummy;
        Sf xn;
        } PSaux;

Sw firstpop ()
{
	Sw ipop;

	clearbadm ();
	samp = ctx.sample;  vst = ctx.vset;
	ipop = -1;
	if (! samp) { printf ("No sample defined for firstpop\n");
		goto finish;  }
	ipop = makepop ();   /* Makes a configured popln */
	if (ipop < 0) goto finish;
	setpop ();
	strcpy (pop->name, "work");


/*	Get stats for root class  */
	rootcl->cnt = samp->nact;
	rootcl->age = 0;
	control = AdjPr;
	doall (2);
	rootcl->type = Pop;  pop->nleaf = 0;
	nosubs = 0;
	ranclass (1);
	doall (2);
	rootcl->relab = 1.0;
finish:
	control = dcontrol;
	return (ipop);
}
/*	----------------------  makesubs -----------------------    */
/*	Given a class index kk, makes two subclasses  */

void makesubs (kk)
	Sw kk;
{
	Class *clp, *clsa, *clsb;
	CVinst *cvi, *scvi;
	Sf cntk;
	Sw i, kka, kkb, iv, nch;

	if (nosubs) return;
	clp = pop->classes [kk];
	setclass (clp);
	clsa = clsb = 0;
/*	Check that class has no subs   */
	if (cls->ison1 >= 0) { i = 0;  goto finish; }
/*	And that it is big enough to support subs    */
	cntk = cls->cnt;
	if (cntk < (2 * MinSize + 2.0))	{ i = 1;  goto finish; }
	kka = makeclass ();
	if (kka < 0) {  i = 2;  goto finish;   }
	clsa = pop->classes[kka];

	kkb = makeclass ();
	if (kkb < 0) {  i = 2;  goto finish;   }
	clsb = pop->classes[kkb];
	clsa->serial = clp->serial + 1;
	clsb->serial = clp->serial + 2;

	setclass (clp);

/*	Fix hierarchy links.  */
	cls->ison1 = kka;  cls->ison2 = kkb;
	clsa->idad = clsb->idad = kk;
	clsa->ison1 = clsa->ison2 = clsb->ison1 = clsb->ison2 = -1;

/*	Copy kk's Basics into both subs  */
	for (iv = 0; iv < nv; iv++)	{
		cvi = cls->basics[iv];
		scvi = clsa->basics[iv];
		nch = vlist[iv].basicsize;
		scvi->signif = 1;
		cmcpy (scvi, cvi, nch);
		scvi = clsb->basics[iv];
		cmcpy (scvi, cvi, nch);
		scvi->signif = 1;
		}

	clsa->age = 0;   clsb->age = 0;
	clsa->type = clsb->type = Sub;
	clsa->relab = clsb->relab = 0.5 * cls->relab;
	clsa->mlogab = clsb->mlogab = cls->mlogab + bit;
	clsa->cnt = clsb->cnt = 0.5 * cls->cnt;
	i = 3;

finish:
	if (i < 3)	{
		if (clsa) { clsa->type = Vacant; clsa->idad = Dead; }
		if (clsb) { clsb->type = Vacant; clsb->idad = Dead; }
		}
	return;
}


/*	-------------------- killpop --------------------  */
/*	To destroy popln index px    */
void killpop (px)
	Sw px;
{
	Sw prev;
	if (ctx.popln) prev = ctx.popln->id;  else prev = -1;
	pop = poplns [px];
	if (! pop) return;

	ctx.popln = pop;  setpop();
	freesp (2);
	freesp (1);
	free (pop);
	poplns[px] = 0;
	pop = ctx.popln = 0;
	if (px == prev) return;
	if (prev < 0) return;
	ctx.popln = poplns[prev];
	setpop();
	return;
}



/*	------------------- copypop ---------------------  */
/*	Copies poplns[p1] into a popln called <newname>.  If no
current popln has this name, it makes one.
	The new popln has the variable-set of p1.
	If <newname> exists, it is discarded.
	Returns index of new popln.
	If newname is "work", the context ctx is left addressing the new
popln, but otherwise is not disturbed.
	*/
Sw copypop (p1, newname)
	Sw p1;
	char *newname;
{
	Popln *fpop;
	Context oldctx;
	Class *cls, *fcls;
	CVinst *cvi, *fcvi;
	EVinst *evi, *fevi;
	Sf nomcnt;
	Sw indx, kk, jdad, nch, skk, i, iv, hiser;

	nomcnt = 0.0;
	cmcpy (&oldctx, &ctx, sizeof (Context));
	indx = -1;
	fpop = poplns [p1];
	if (! fpop) {
		printf ("No popln index %d\n", p1);
		indx = -106;  goto finish;
		}
	kk = vname2id (fpop->vstname);
	if (kk < 0)	{
		printf ("No Variable-set %s\n", fpop->vstname);
		indx = -101;  goto finish;
		}
	vst = ctx.vset = vsets [kk];

/*	See if destn popln already exists  */
	i = pname2id (newname);
/*	Check for copying into self  */
	if (i == p1)	{
		printf ("From copypop: attempt to copy model%3d into itself\n", p1+1);
		indx = -102;  goto finish;  }
	if (i >= 0) killpop (i);
/*	Make a new popln  */
	indx = makepop ();
	if (indx < 0)	{
		printf ("Cant make new popln from%4d\n", p1+1);
		indx = -104;  goto finish;
		}

	ctx.popln = poplns [indx];  setpop();
	strcpy (pop->samplename, fpop->samplename);
	pop->samplesize = fpop->samplesize;
	if (samp) pop->nc = samp->nc;  else pop->nc = 0;
	strcpy (pop->name, newname);
	hiser = 0;
	pop->cost = fpop->cost;

/*	We must begin copying classes, begining with fpop's root  */
	fcls = fpop->classes[root];  jdad = -1;
/*	In case the pop is unattached (fpop->nc = 0), prepare a nominal
count to insert in leaf classes  */
	nomcnt = samp->nact;  nomcnt = nomcnt / fpop->nleaf;

newclass:
	if (fcls->idad < 0)	kk = pop->root;
	else  kk = makeclass();
	if (kk < 0) { indx = -105;  goto finish; }
	cls = pop->classes[kk];
	nch = ((char*) & cls->id) - ((char*) cls);
	cmcpy (cls, fcls, nch);
	cls->ison1 = cls->ison2 = -1;
	cls->idad = jdad;

/*	Copy Basics. the structures should have been made.  */
	for (iv = 0; iv < nv; iv++)	{
		fcvi = fcls->basics[iv];
		cvi = cls->basics[iv];
		nch = vlist[iv].basicsize;
		cmcpy (cvi, fcvi, nch);
		}

/*	Copy stats  */
	for (iv = 0; iv < nv; iv++)        {
		fevi = fcls->stats[iv];
		evi = cls->stats[iv];
		nch = vlist[iv].statssize;
		cmcpy (evi, fevi, nch);
		}
/*	If fpop is not attached, we cannot copy thing-specific data */
	if (fpop->nc) goto classdone;

	cls->newcnt = nomcnt;
	if (cls->idad < 0)   /* Root class */   cls->newcnt = samp->nact;

classdone:
/*	First time, we have just copied root. Subsequently, we will
	copy leaves. We do not copy subs or trial-combine.  */
/*	We try to move on to the next leaf, if any  */
/*	The index in fpop of the class just copied is fcls->id  */
	if (cls->serial > hiser) hiser = cls->serial;
	if (jdad < 0)	/* just copied root  */
		{  skk = -1;  jdad = fcls->id; }
	else { cls->serial = pop->nextserial<<2; pop->nextserial++; }
nextleaf:
	skk ++;
	if (skk > fpop->hicl) goto alldone;
	if ((! fpop->classes[skk]) || (fpop->classes[skk]->type != Leaf))
		goto nextleaf;
	fcls = fpop->classes[skk];
	goto newclass;

alldone:	/*  All classes copied. Tidy up */
	tidy (0);
	pop->nextserial = (hiser >> 2) + 1;

finish:
/*	Unless newname = "work", revert to old context  */
	if (strcmp (newname, "work") || (indx < 0))
		ctx.popln = oldctx.popln;
	ctx.sample = oldctx.sample;
	setpop ();
	return (indx);
}


/*	----------------------  printsubtree  ----------------------   */
void printsubtree(kk)
	Sw kk;
{
	Class *clp;

	clp = pop->classes [kk];
	if (clp->type == Leaf) printf ("   ");
	if (clp->type == Sub) printf ("      ");
	if (clp->type == TC) printf (" TC");
	if (clp->type == Pop) printf ("POP");
	printf ("%s", sers (clp));
	printf(" RelAb%6.3f  Size%8.1f", clp->relab, clp->newcnt);
	if (clp->type == TC)	{
		printf ("  =%4d", pop->classes[clp->ison1]->serial>>2);
		printf (" +%4d", pop->classes[clp->ison2]->serial>>2);
		}
	printf ("\n");

	return;
}

/*	---------------------  printtree  ---------------------------  */
void printtree()
{

	Class *clp;
	Sw kk, nkk, lser, nser;

	flp();
	pop = ctx.popln;
	if (! pop)	{
		printf ("No current population.\n");  return;
		}
	setpop();
	printf ("Popln%3d on sample%3d,%4d leaves,%6d things",
		pop->id+1, samp->id+1, pop->nleaf, samp->nc);
	printf ("  Cost %10.2f\n", pop->cost);
	printf("\n  Assign mode ");
	if (fix == Partial) printf ("Partial    ");
	if (fix == Most_likely) printf ("Most_likely");
	if (fix == Random) printf ("Random     ");
	printf ("--- Adjust:");
	if (control&AdjPr) printf(" Params");
	if (control & AdjTr) printf(" Tree");
	printf ("\n");
	printsubtree (root);
/*	Print leaves (and their subs) in order of serial number  */
	lser = 0;
nextleaf:
	nkk = -1;  nser = (pop->nextserial << 2) + 1;
	for (kk = 0; kk <= pop->hicl; kk++)	{
		clp = pop->classes[kk];
		if (clp && (clp->type == Leaf))	{
			if ((clp->serial > lser) && (clp->serial < nser))  {
				nkk = kk;  nser = clp->serial;
				}
			}
		}
	if (nkk >= 0)	{
		printsubtree (nkk);
		clp = pop->classes[nkk];
		lser = clp->serial;
		if (clp->ison1 >= 0)	{
			printsubtree (clp->ison1);
			printsubtree (clp->ison2);
			}
		goto nextleaf;
		}
	if (pop->tcic >= 0) printsubtree (pop->tcic);
	return;
}


/*	--------------------  bestpopid  -----------------------------  */
/*	Finds the popln whose name is "BST_" followed by the name of
ctx.samp.  If no such popln exists, makes one by copying ctx.popln.
Returns id of popln, or -1 if failure  */

/*	The char BSTname[] is used to pass the popln name to trackbest */
	char BSTname[80];

Sw bestpopid ()
{
	Sw i;

	i = -1;
	if (! ctx.popln) goto gotit;  if (! ctx.sample) goto gotit;
	setpop ();

	strcpy (BSTname, "BST_");  strcpy (BSTname+4, samp->name);
	i = pname2id (BSTname);
	if (i >= 0) goto gotit;

/*	No such popln exists.  Make one using copypop  */
	i = copypop (pop->id, BSTname);
	if (i < 0) goto gotit;
/*	Set bestcost in samp from current cost  */
	samp->bestcost = pop->cost;
/*	Set goodtime as current pop age  */
	samp->goodtime = pop->classes[root]->age;

gotit:
	return (i);
}


/*	-----------------------  trackbest  ----------------------------  */
/*	If current model is better than 'BST_...', updates BST_... */
void trackbest (verify)
	Sw verify;
{
	Popln *bstpop;
	Sw bstid, bstroot, kk;
	Sf bstcst;

	if (! ctx.popln) return;
/*	Check current popln is 'work'  */
	if (strcmp ("work", ctx.popln->name)) return;
/*	Check work has been adjusted to current sample  */
	if (strcmp (ctx.sample->name, ctx.popln->samplename)) return;
/*	Don't believe cost if fix is random  */
	if (fix == Random) return;
/*	If no leaves, forget it.  */
	if (ctx.popln->nleaf < 1) return;
/*	Compare current and best costs  */
	bstid = bestpopid ();
	if (bstid < 0)	{
		printf ("Cannot make BST_ model\n");
		return;	}
	bstpop = poplns [bstid];
	bstroot = bstpop->root;
	bstcst = bstpop->cost;
	if (pop->cost >= bstcst) return;
/*	Current looks better, but do a doall to ensure cost is correct */
/*	But only bother if 'verify'  */
	if (verify)	{
		kk = control;  control = 0;  doall (1);  control = kk;
		if (pop->cost >= bstcst) return;
		}

/*	Seems better, so kill old 'bestmodel' and make a new one */
	setpop ();
	kk = copypop (pop->id, BSTname);
	samp->bestcost = pop->cost;
	samp->goodtime = pop->classes[root]->age;
	return;
}


/*	------------------  pname2id  -----------------------------   */
/*	To find a popln with given name and return its id, or -1 if fail */
Sw pname2id (nam)
	Sc *nam;
{
	Sw i;
	char lname [80];

	strcpy (lname, "BST_");
	if (strcmp (nam, lname)) strcpy (lname, nam);
	else {
		if (ctx.sample)	strcpy (lname+4, ctx.sample->name);
		else return (-1);
		}
	for (i = 0; i < Maxpoplns; i++)	{
		if (poplns[i] && (! strcmp (lname, poplns[i]->name)))
			return (i);
		}
	return (-1);
}


/*	--------------  recordit  -----------------------  */
/*	To write characters to a file  */
void recordit (fll, from, nn)
	FILE *fll;  char *from;  Sw nn;
{
	Sw i;
	for (i = 0; i < nn; i++)	{
		fputc (*from, fll);  from++;
		}
	return;
}


/*	------------------- savepop ---------------------  */
/*	Copies poplns[p1] into a file called <newname>.
	Returns length of recorded file.
	*/

Sw savepop (p1, newname)
	Sw p1;
	char *newname;
{
	FILE *fl;
	char oldname [80], *jp;
	Context oldctx;
	Class *cls;
	CVinst *cvi;
	EVinst *evi;
	Sw leng, nch, i, iv, nc, jcl;

	cmcpy (&oldctx, &ctx, sizeof(Context));
	fl = 0;
	if (! poplns[p1])  {
		printf ("No popln index %d\n", p1);
		leng = -106;  goto finish;
		}
/*	Begin by copying the popln to a clean TrialPop   */
	pop = poplns[p1];
	if (! strcmp (pop->name, "TrialPop"))	{
		printf ("Cannot save TrialPop\n");
		leng = -105;  goto finish;
		}
/*	Save old name  */
	strcpy (oldname, pop->name);
	i = pname2id ("TrialPop");
	if (i >= 0) killpop (i);
	nc = pop->nc;
	i = copypop (p1, "TrialPop");
	if (i < 0) { leng = i; goto finish;  }
/*	We can now be sure that, in TrialPop, all subs are gone and classes
	have id-s from 0 up, starting with root  */
/*	switch context to TrialPop  */
	ctx.popln = poplns[i];   setpop ();
	vst = ctx.vset = vsets [vname2id (pop->vstname)];
	nc = pop->nc;

	fl = fopen (newname, "w");
	if (! fl)	{
		printf("Cannot open %s\n", newname);  leng = -102;
		goto finish;
		}
/*	Output some heading material  */
	for (jp = saveheading; *jp; jp++) { fputc(*jp, fl);}
	fputc ('\n', fl); 
	for (jp = oldname; *jp; jp++) { fputc(*jp, fl);}
	fputc ('\n', fl); 
	for (jp = pop->vstname; *jp; jp++) { fputc(*jp, fl);}
	fputc ('\n', fl); 
	for (jp = pop->samplename; *jp; jp++) { fputc(*jp, fl);}
	fputc ('\n', fl); 
	fprintf (fl, "%4d %10d %10.1f", pop->ncl, nc, pop->cost);
	fputc ('+', fl);  fputc ('\n', fl);

/*	We must begin copying classes, begining with pop's root  */
	jcl = 0;
/*	The classes should be lined up in pop->classes  */

newclass:
	cls = pop->classes [jcl];
	cls->newcnt = cls->cnt;
	leng = 0;
	nch = ((char*) & cls->id) - ((char*) cls);
	recordit (fl, cls, nch);  leng += nch;

/*	Copy Basics..  */
	for (iv = 0; iv < nv; iv++)	{
		cvi = cls->basics[iv];
		nch = vlist[iv].basicsize;
		recordit (fl, cvi, nch);  leng += nch;
		}

/*	Copy stats  */
	for (iv = 0; iv < nv; iv++)        {
		evi = cls->stats[iv];
		nch = vlist[iv].statssize;
		recordit (fl, evi, nch);  leng += nch;
		}
	jcl++;  if (jcl < pop->ncl) goto newclass;

finish:
	fclose (fl);
	printf ("\nModel  Cost %10.2f  saved in file %s\n",
		pop->cost, newname);
	cmcpy (&ctx, &oldctx, sizeof (Context));
	setpop();
	return (leng);
}


/*	-----------------  rsave  -------------------------------  */
/*	To read a model saved by savepop  */
Sw rsave (nam)
	char *nam;
{
	char pname[80], name[80], *jp;
	Context oldctx;
	Sw i, j, k, indx, fncl, fnc, nch, iv;
	Sf fcost;
	Class *cls;
	CVinst *cvi;  EVinst *evi;
	FILE *fl;

	indx = -999;
	cmcpy (&oldctx, &ctx, sizeof (Context));
	fl = fopen (nam, "r");
	if (! fl) { printf("Cannot open %s\n", nam);  goto error; }
	fscanf (fl, "%s", name);
	if (strcmp (name, saveheading))	{
		printf ("File is not a VanillaSnob save-file\n"); goto error; }
	fscanf (fl, "%s", pname);
	printf ("Model %s\n", pname);
	fscanf (fl, "%s", name);   /* Reading v-set name */
	j = vname2id (name);
	if (j < 0)	{
		printf("Model needs variableset %s\n", name);  goto error; }
	vst = ctx.vset = vsets [j];  nv = vst->nv;
	fscanf (fl, "%s", name);   /* Reading sample name */
	fscanf (fl, "%d%d%lf", &fncl, &fnc, &fcost);
		/* num of classes, cases, cost  */
/*	Advance to real data */
	while (fgetc (fl) != '+');  fgetc (fl);
	if (fnc)	{
		j = sname2id (name, 1);
		if (j < 0)	{
			printf("Sample %s unknown.\n", name);
			nc = 0;  samp = ctx.sample = 0;
			}
		else	{
			samp = ctx.sample = samples[j];
			if (samp->nc != fnc)	{
				printf("Size conflict Model%9d vs. Sample%9d\n",
					fnc, nc);  goto error;  }
			nc = fnc;
			}
		}
	else	{	/* file model unattached.  */
		samp = ctx.sample = 0;  nc = 0;
		}

/*	Build input model in TrialPop  */
	j = pname2id ("TrialPop");
	if (j >= 0) killpop (j);
	indx = makepop ();
	if (indx < 0) goto error;
	pop = ctx.popln = poplns[indx];  pop->nc = nc;
	pop->cost = fcost;
	strcpy (pop->name, "TrialPop");
	if (! nc) strcpy (pop->samplename, "??");
	setpop ();  pop->nleaf = 0;
/*	Popln has a root class set up. We read into it.  */
	j = 0;  goto haveclass;

newclass:
	j = makeclass ();
	if (j < 0) { printf("RestoreClass fails in Makeclass\n"); goto error; }
haveclass:
	cls = pop->classes[j];
	jp = (char*) cls;  nch = ((char*) &cls->id) - jp;
	for (k = 0; k < nch; k++) {*jp = fgetc(fl); jp++; }
	for (iv = 0; iv < nv; iv++)	{
		cvi = cls->basics[iv];  nch = vlist[iv].basicsize;
		jp = (char*) cvi;
		for (k = 0; k < nch; k++) {*jp = fgetc(fl); jp++; }
		}
	for (iv = 0; iv < nv; iv++)     {
		evi = cls->stats[iv];  nch = vlist[iv].statssize;
		jp = (char*) evi;
		for (k = 0; k < nch; k++) {*jp = fgetc(fl); jp++; }
		}
	if (cls->type == Leaf) pop->nleaf++;
	if (pop->ncl < fncl) goto newclass;

	i = pname2id (pname);
	if (i >= 0)	{
		printf ("Overwriting old model %s\n", pname);
		killpop (i);
		}
	if ( ! strcmp (pname, "work"))  goto pickwork;
	strcpy (pop->name, pname);
error:
	cmcpy (&ctx, &oldctx, sizeof (Context));  goto finish;

pickwork:
	indx = loadpop (pop->id);
	j = pname2id ("TrialPop");  if (j >= 0) killpop (j);
finish:
	setpop (); return (indx);
}


/*	----------------------  loadpop  -----------------------------  */
/*	To load popln pp into work, attaching sample as needed.
	Returns index of work, and sets ctx, or returns neg if fail  */
Sw loadpop (pp)
	Sw pp;
{
	Sw j, windx, fpopnc;
	Context oldctx;
	Popln *fpop;

	windx = -1;
	cmcpy (& oldctx, &ctx, sizeof (Context));
	fpop = 0;
	if (pp < 0) goto error;
	fpop = pop = poplns[pp];  if (! pop) goto error;
/*	Save the 'nc' of the popln to be loaded  */
	fpopnc = pop->nc;
/*	Check popln vset  */
	j = vname2id (pop->vstname);
	if (j < 0) {
		printf ("Load cannot find variable set\n");  goto error; }
	vst = ctx.vset = vsets[j];
/*	Check Vset  */
	if (strcmp (vst->name, oldctx.sample->vstname))	{
		printf ("Picked popln has incompatible VariableSet\n");
		goto error;
		}
/*	Check sample   */
	if (fpopnc && strcmp (pop->samplename, oldctx.sample->name))  {
		printf ("Picked popln attached to non-current sample.\n");
	/*	Make pop appear unattached  */
		fpop->nc = 0;
		}

	ctx.sample = samp = oldctx.sample;
	windx = copypop (pp, "work");  if (windx < 0) goto error;
	ctx.popln = poplns [windx];
	setpop ();
	rootcl->newcnt = samp->nact;
	if (! fpop->nc) {
		rootcl->age = 0;
		control = AdjPr;
		while (rootcl->age < 3) doall (1);
		}
	control = 0;  doall (1);  /* To get costs right */
	control = dcontrol;
	printtree();  clearbadm();

finish:
/*	Restore 'nc' of copied popln  */
	if (fpop) fpop->nc = fpopnc;
	setpop();
	return (windx);

error:
	cmcpy (&ctx, &oldctx, sizeof (Context));
	goto finish;
}


/*	-------------  crosstab  ----------------------  */
/*	Given a popln id attached to same sample as 'work' popln,
prints the overlap between the leaves of one popln and leaves of other.
The output is a cross-tabulation table of the leaves of 'work' against the
leaves of the chosen popln, which must be attached to the current sample.
Table entries show the weight assigned to both one leaf of 'work' and one
leaf of the other popln, as a permillage of active things.
	*/
void crosstab (xid)
	Sw xid;
{
	float table [MaxClasses][MaxClasses];
	Class *wsons[MaxClasses], *xsons[MaxClasses];
	Popln *xpop, *wpop;
	Sf fnact, wwt;
	Sw wic, xic, n, pcw, wnl, xnl;


	setpop ();
	wpop = pop;
	xpop = poplns[xid];
	if (! xpop)	{
		printf ("No such model\n");  goto finish;  }
/*	Should be able to proceed  */
	fnact = samp->nact;
	control = 0;
	nosubs ++;  doall (2);
	wpop = pop;
	findall (Leaf);
	wnl = numson;
	for (wic = 0; wic < wnl; wic++) wsons[wic] = sons[wic];
/*	Switch to xpop  */
	ctx.popln = xpop;  setpop();
	doall (2);
/*	Find all leaves of xpop  */
	findall (Leaf);  xnl = numson;
	if ((wnl < 2) || (xnl < 2))	{
		printf ("Need at least 2 classes in each model.\n");
		goto finish;
		}
	for (xic = 0; xic < xnl; xic++) xsons[xic] = sons[xic];
/*	Clear table   */
	for (wic = 0; wic < wnl; wic++)	{
		for (xic = 0; xic < xnl; xic++) table [wic][xic] = 0.0;
		}

/*	Now accumulate cross products of weights for each active thing */
	for (n = 0; n < nc; n++)	{
		ctx.popln = wpop;  setpop ();
		rec = recs + n * reclen;
		if (! *rec) goto ndone;
		findall (Leaf);
		docase (n, 0);
		ctx.popln = xpop;  setpop();
		findall (Leaf);
		docase (n, 0);
	/*	Should now have caseweights set in leaves of both poplns  */
		for (wic = 0; wic < wnl; wic++) {
			wwt = wsons[wic]->casewt;
			for (xic = 0; xic < xnl; xic++) {
				table[wic][xic] += wwt * xsons[xic]->casewt;
				}
			}
	ndone:	;
		}

/*	Print results	*/
	flp();
	printf ("Cross tabulation of popln classes as permillages.\n");
	printf ("Rows show 'work' classes, Columns show 'other' classes.\n");
	printf ("\nSer:");
	for (xic = 0; xic < xnl; xic++)
		printf ("%3d:", xsons[xic]->serial / 4);
	printf ("\n");
	fnact = 1000.0 / fnact;
	for (wic = 0; wic < wnl; wic++) {
		printf ("%3d:", wsons[wic]->serial / 4);
		for (xic = 0; xic < xnl; xic++) {
			pcw = table[wic][xic] * fnact + 0.5;
			if (pcw > 999) pcw = 999;
			printf ("%4d", pcw);
			}
		printf ("\n");
		}

finish:
	if (nosubs > 0) nosubs--;
	ctx.popln = wpop;  setpop();
	doall (1);
	control = dcontrol;
	return;
}


/*	-----------------  rmrep  ---------------------------------  */
/*	To read in a 'mrep' file and constuct a model as "work"  */
/*	Checks heading, sample name.
	*/

Sw rmrep (memname)
	char *memname;
{
	FILE *fl;
	Sw numc, err, nn, cser, hiser, tid, ic;
	Sw i;
	Sf ab;
	char name[80];
	PSaux *psaux;

/*	Open the file  */
	fl = fopen (memname, "r");
	if (! fl)	{
		printf ("Cant open %s\n", memname);
		return (-1);
		}
	fscanf (fl, "%s", name);
	if (strcmp (name, mrepheading))	{
		printf ("File is not a VanillaSnob Member file\n");
		err = -2;  goto ferror;
		}

	setpop ();
	fscanf (fl, "%s", name);
	fscanf (fl, "%s", name);
	if (strcmp (name, samp->name)) {
		printf ("File is not for current sample\n");
		err = -3;  goto ferror;
		}
	if (fscanf (fl, "%d", &numc ) != 1)  {
		err = -4;  goto ferror;
		}
/*	numc gives number of classes  */
	if (numc < 2)	{
		printf ("Silly number of classes %d\n", numc);
		err = -5;  goto ferror;
		}
	ab = 1.0 / numc;

/*	Make numc leaves  */
	clobber (numc);
/*	Skip to first class  */
	hiser = 0;
	while (fgetc (fl) != '+');
	findall (Leaf); ic = 0;
	control = AdjPr;

newclass:
	cls = sons[ic];
	if (fscanf (fl, "%s %d", name, &cser) != 2)   {
		err = -6;  goto ferror;
		}
	while (fgetc (fl) != '\n');
	if (cser > hiser) hiser = cser;
	cls->serial = cser << 2;
	cleartcosts (cls);
	cls->casewt = 1.0;
	cls->casecost = 1000.0;
/*	Read in thing identifiers belonging to the class  */
newthing:
	if (fscanf (fl, "%d", &tid) != 1)   {
		err = -7;  goto ferror;
		}
	if (tid == -1) goto membersin;
	nn = id2ind (tid);
	if (nn < 0)	{
		printf ("No thing identifier %d in sample.\n", tid);
		err = -8;  goto ferror;
		}
	rec = samp->recs + nn * reclen;
        thing = nn;
        if (! *rec) goto newthing;  /* Inactive thing */

/*      Unpack data into 'xn' fields of the Saux for each variable. The
'xn' field is at the beginning of the Saux. Also the "missing" flag. */
        for (i = 0; i < nv; i++)        {
                loc = rec + svars[i].offset;
                psaux = (PSaux *) svars[i].saux;
                if (*loc == 1)  { psaux->missing = 1; }
                else    {
                        psaux->missing = 0;
                        cmcpy (& (psaux->xn), loc+1, vlist[i].vtp->datsize);
                        }
                }
	cls->casecost = 1000.0;
	derivvarall (cls);
	goto newthing;

membersin:	/*  All members of class read in */
	if (cls->newcnt)	{
		adjustclass (cls);
		cls->relab = ab;
		}
	ic++;  if (ic < numc) goto newclass;

	pop->nextserial = hiser + 1;
	fix = Partial;  nosubs = 1;
	doall (2);
	printtree();
	control = AdjPr + AdjTr;
	err = 0;

ferror:
	fclose (fl);
	clearbadm ();
	return (err);
}


/*	---------------------------  adv  -------------------  */
/*	To read file fl until a '>' is found. Returns 1 if EOF  */
Sw adv (fl)
	FILE *fl;
{
	Sw cha;

nextch:
	cha = fgetc (fl);
	if (cha == EOF) return (1);
	if (cha != '#') goto nextch;
	return (0);
}


/*	---------------------  rprep  ------------------------  */
/*	To restore a popln model from a .prep file  */
Sw rprep (nam)
	char *nam;
{
	char pname[80], name[80];
	Context oldctx;
	Sw i,j, indx, err, nlf, hiser, iv;
	Sf cost, sampsz, totsz;
	Class *cls;
	FILE *fl;

	err = 0;
	cmcpy (&oldctx, &ctx, sizeof (Context));
	fl = fopen (nam, "r");
	if (! fl) { printf("Cannot open %s\n", nam);  err = 91; goto error; }
	fscanf (fl, "%s", name);
	if (strcmp (name, saveheading))	{
		printf ("File is not a VanillaSnob-Model file\n"); err = 92;
			 goto error; }
	fscanf (fl, "%s", pname);
	printf ("Model %s\n", pname);
	err = adv(fl);  if (err) goto error;
/*	Read Vset name  */
	if (fscanf (fl, "%s", name) != 1)  { err = 93; goto error; }
	j = vname2id (name);
	if (j < 0)	{
		printf("Model needs variableset %s\n", name); err = 94;
			goto error; }
	vst = ctx.vset = vsets [j];  nv = vst->nv;
	err = adv(fl);  if (err) goto error;
/*	Read sample name  */
	if (fscanf (fl, "%s", name) != 1)  { err = 95; goto error; }
/*	Read samplesize	*/
	err = adv(fl);  if (err) goto error;
	if (fscanf (fl, "%lf", &sampsz) != 1) { err = 96; goto error; }
	if (sampsz < 10.0) sampsz = 9999.0;  /* A notional value */
/*	Read cost  */
	err = adv(fl);  if (err) goto error;
	if (fscanf (fl, "%lf", &cost) != 1) { err = 97; goto error; }
/*	Read number of leaves  */
	err = adv(fl);  if (err) goto error;
	if (fscanf (fl, "%d", &nlf) != 1) {err = 98;  goto error; }
/*	Build input model in TrialPop  */
	j = pname2id ("TrialPop");
	if (j >= 0) killpop (j);
	indx = makepop ();
	if (indx < 0)  {err = 99;  goto error; }
	pop = ctx.popln = poplns[indx];  pop->nc = sampsz;
	pop->cost = cost;
	strcpy (pop->name, "TrialPop");
	strcpy (pop->samplename, name);
	setpop ();  pop->nleaf = 0;
/*	Popln has a root class set up. We read into it.  */
	totsz = 0.0;   /* will sum the leaf sizes */
	hiser = -1;

newclass:
/*	Read serial  */
	err = adv(fl);  if (err) goto error;
	if (fscanf (fl, "%d", &i) != 1) { err = 82; goto error; }
/*	If first class is not serial 0, there will be no Pop class in file,
	so we leave it undefined, set pop->nc = 0, and query samplename */
	if (hiser < 0)	{
		if (i == 0) { j = 0;  pop->nc = sampsz;  } /* Pop class */
		else {
			pop->nc = 0;  strcpy (pop->samplename, "???");
			}
		}
	if (i > 0) { j = makeclass(); }
	if (j < 0) { printf("RestoreClass fails in Makeclass\n");
		err = 81;  goto error; }
	cls = pop->classes[j];
	if (i > hiser) hiser = i;
	cls->serial = i << 2;
/*	Read age  */
	err = adv(fl);  if (err) goto error;
	if (fscanf (fl, "%d", &(cls->age)) != 1) { err = 83; goto error; }
	cls->ison1 = cls->ison2 = -1;
/*	Read sample size  */
	err = adv(fl);  if (err) goto error;
	if (fscanf (fl, "%lf", &(cls->cnt)) != 1) { err = 84; goto error; }
	if (cls->cnt < 1.0)	{ err = 85; goto error; }
	cls->newcnt = 0.0;
	if (i == 0)	{
		cls->idad = -1;
		cls->type = Pop;
		if (! (pop->nc)) cls->age = 0;
		}
	else	{
		cls->idad = root;
		cls->type = Leaf;
		cls->age = 2;
		pop->nleaf ++;
		totsz += cls->cnt;
		}

/*	read variable parameters  */
	for (iv = 0; iv < nv; iv++)	{
		vtp = vlist[iv].vtp;
		err = (*vtp->inpar) (cls, iv, fl);
		if (err) goto error;
		}
	cls->cbcost = cls->cbpcost = cls->cbtcost = 1.0e6;
	if (pop->nleaf < nlf) goto newclass;

/*	All classes in. Fix relabs etc  */
	pop->nextserial = hiser + 1;
	pop->ncl = nlf + 1;
/*	Have total class cnts in totsz. Use to calc relabs  */
	for (i = 1; i <= pop->hicl; i++)  {
		cls = pop->classes[i];
		cls->relab = (cls->cnt + 0.5) / (totsz + 0.5 * nlf);
		cls->mlogab = -log (cls->relab);
		}
	rootcl->relab = 1.0;  rootcl->mlogab = 0.0;
	rootcl->cnt = totsz;

	i = pname2id (pname);
	if (i >= 0)	{
		printf ("Overwriting old model %s\n", pname);
		killpop (i);
		}
	strcpy (pop->name, pname);
finish:
	cmcpy (&ctx, &oldctx, sizeof (Context));
	j = pname2id ("TrialPop");  if (j >= 0) killpop (j);
	setpop (); return (indx);

error:
	printf ("\nError %2d in rprep\n", err);
	indx = -err;  goto finish;
}


