/*	-----------------  fiddles with tree structure  ----------------  */
#define NOTGLOB 1
#define TACTICS 1
#include "glob.c"

/*     --------------------  flatten  --------------------------------  */
/*	Splits all leaves  */
void flatten ()
{

	Sw i;

	setpop ();
	tidy (0);
	findall (Leaf);
	for (i = 0; i < numson; i++)	{
		splitleaf (sons[i]->id);
		}
	nosubs ++;
	tidy (0);
	rootcl->type = Pop;
	if (nosubs > 0) nosubs --;
	printtree ();
	return;
}

/*	------------------  ranclass  --------------------------  */
/*	To make nn random classes  */
void ranclass (nn)
	Sw nn;
{

	if (nn < 1) goto finish;
	setpop ();
	if (! pop) { printf("Ranclass needs a model\n");  goto finish; }
	if (! pop->nc) { printf("Model has no sample\n"); goto finish; }
	if (nn > (pop->mncl - 2)) {printf("Too many classes\n"); goto finish; }

	nosubs = 1;
	control = AdjPr + AdjTr;  fix = Random;
	clobber (nn);
	if (nn > 1) nosubs = 1;  else nosubs = 0;
	doall (1);
	control = dcontrol;
	fix = dfix;
	doall (1);
	printtree();
	nosubs = 0;

finish:	return;
}


/*	------------------  addstats  ---------------------------   */
/*	Forms a class cls by combining classes indices ison1, ison2
	Returns an appoximate cost increase   */
Sf addstats (ison1, ison2)
	Sw ison1, ison2;
{
	Class *son1, *son2;
	Sw iv, n, nw;
	Sf *wp1, *wp2, *wpc, cost;

	son1 = pop->classes[ison1];  son2 = pop->classes[ison2];
	cls->ison1 = ison1;  cls->ison2 = ison2;
	cls->cnt = son1->cnt + son2->cnt;
	cls->newcnt = son1->newcnt + son2->newcnt;
	cls->relab = son1->relab + son2->relab;
	cls->mlogab = - log (cls->relab);
	for (iv = 0; iv < nv; iv++)	{
		avi = vlist + iv;
		nw = avi->statssize / sizeof (Sf);
		wp1 = (Sf*) (son1->stats[iv]);
		wp2 = (Sf*) (son2->stats[iv]);
		wpc = (Sf*) (cls->stats[iv]);
		for (n = 0; n < nw; n++)	{
			*wpc = *wp1 + *wp2;
			wpc++;  wp1++; wp2++;
			}
		}
	cls->age = 1;  adjustclass (cls);
	cls->ison1 = son1->id;  cls->ison2 = son2->id;
	cost = cls->cdtcost - son1->cdtcost - son2->cdtcost
	     + cls->cbpcost - son1->cbpcost - son2->cbpcost;
	return (cost);
}


/*	------------------  trycombine  -------------------------    */
/*	To choose and set up a trial combine (TC) class      */
void trycombine ()
{
	Sf cost, lowcost;
	Sw ic1, ic2, bs1, bs2;
	Class *son1, *son2;

	setpop ();
	if (pop->tcic >= 0) {
		cls = pop->classes[pop->tcic];
	/*	This TC class will be discarded  */
		cls->type = Vacant;
		if ((cls->serial >> 2) == (pop->nextserial-1))
			pop->nextserial--;
		pop->ncl --;
		pop->tcic = -1;
		son1 = pop->classes[cls->ison1];
		son2 = pop->classes[cls->ison2];
		setbadm (1, son1->serial, son2->serial);
		}

	if (! (control & AdjTr)) return;
	findall (Leaf);
	if (numson < 3)	goto finish;
	pop->tcic = makeclass ();
	if (pop->tcic < 0) goto finish;

	cls = pop->classes [pop->tcic];
	cls->type = TC;
	setclass (cls);
	cls->idad = root;
	cls->serial = pop->nextserial << 2;
	pop->nextserial ++;

/*	Scan all pairs of leves looking for a good one  */
	lowcost = 1.0e30;
	bs1 = bs2 = -1;
	control = AdjPr;

	for (ic1 = 0; ic1 < (numson-1); ic1++)	{
		son1 = sons[ic1];
		if (son1->age < 10) goto endic1;
		for (ic2 = ic1+1; ic2 < numson; ic2++)	{
			son2 = sons[ic2];
			if (son2->age < 10) goto endic2;
		/*	Test if a known bad move  */
			if (testbadm (1, son1->serial, son2->serial))
				goto endic2;
		/*	We will try the pair son1, son2.  */
		/*	Add their stats into cls  */
			cost = addstats (son1->id, son2->id);
			if (cost < lowcost)	{
				lowcost = cost;  bs1 = ic1;  bs2 = ic2;
				}
		endic2:	;
			}  /* End ic2 loop */
	endic1:	;
		}  /* End ic1 loop */

	if (bs1 < 0)	{
	/*ddd
		flp();  printf ("No combineable pair\n");
		*/
		pop->tcic = -1;
		cls->type = Vacant;
		pop->ncl --;
		if ((cls->serial >> 2) == (pop->nextserial-1))
			pop->nextserial --;
		goto finish;
		}

	son1 = sons[bs1];  son2 = sons[bs2];
/*ddd
	flp();
	printf ("Cycle%7d  Trying combine of %4d, %4d  Approx cost %9.2f\n",
		cycle, son1->serial>>2, son2->serial>>2, lowcost);
	*/
	cost = addstats (son1->id, son2->id);

finish:
	control = dcontrol;
	return;
}


/*	-------------------  combine  ------------------------------  */
/*	To combine two leaves forcibly. Returns approx cost  */
Sw combine (ison1, ison2)
	Sw ison1, ison2;
{
	Class *son1, *son2;
	Sf cost;
	Sw icls;

	setpop ();
	tidy (1);
	cost = 1.1e20;
	control = AdjTr + AdjPr;
/*	Kill any TC class  */
	if (pop->tcic >= 0)	{
		cls = pop->classes[pop->tcic];
		cls->type = Vacant;
		if ((cls->serial >> 2) == (pop->nextserial-1))
			pop->nextserial --;
		pop->ncl--;
		pop->tcic = -1;
		}

	son1 = pop->classes[ison1];
	son2 = pop->classes[ison2];
	if ((!son1) || (son1->type != Leaf) ||
	    (!son1) || (son1->type != Leaf)) goto fail;

	icls = makeclass ();
	if (! icls) goto fail;
	cls = pop->classes[icls];
	setclass (cls);
	cls->type = Leaf;
	cls->idad = root;
	cls->serial = pop->nextserial << 2;
	pop->nextserial ++;

/*	Kill any subs of son1, son2  */
	killsons (ison1);  killsons (ison2);

	son1->type = Sub;  son2->type = Sub;  pop->nleaf--;
	son1->idad = son2->idad = icls;
	cost = addstats (ison1, ison2);

	printf ("Combine%5d,%5d into%5d for rough cost%8.2f\n",
		son1->serial>>2, son2->serial>>2, cls->serial>>2, cost);
	son1->serial = cls->serial+1;  son2->serial = cls->serial+2;
	control = AdjPr;  fix = Partial;
	doall (1);
	control = dcontrol;  fix = dfix;
	return (0);

fail:	printf ("Combine fails\n");
	control = dcontrol;
	return (-1);
}
